/*
 * Modal
 *
 * Index
 * - Overlay
 * - Modal
 * - Content
 * - Header
 * - Actions
 * - Title
 * - Body
 */

/**
 * @prop --z-index: The z-index of the Modal.
 */


/* OVERLAY
 -------------------- */

:host {
  --z-index: 3;

  position: fixed;
  top: 0;
  left: 0;
  z-index: var(--z-index);
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 100%;
  overflow: hidden;
  font-family: var(--road-font, sans-serif);
  line-height: 1.5;
  color: var(--road-grey-900);
  visibility: hidden !important;
  opacity: 0;
  transition: opacity 0.15s linear, visibility 0.15s;
}

/* OVERLAY
 -------------------- */

.modal-overlay {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  display: block;
  touch-action: none;
  cursor: pointer;
  background: var(--road-overlay);
}

/* MODAL
 -------------------- */

.modal-dialog {
  position: relative;
  width: 100%;
  pointer-events: none;
  transition: transform 0.3s ease-out;
  transform: translateY(50px);
}

/**
 * Open state
 */

:host(.modal-open) {
  visibility: visible !important;
  opacity: 1;
}

:host(.modal-open) .modal-dialog {
  transform: none;
}

/* CONTENT
 -------------------- */

.modal-content {
  position: relative;
  display: flex;
  flex-direction: column;
  width: 100%;
  height: 100vh;
  pointer-events: auto;
  background: var(--road-surface);
  background-clip: padding-box;
  box-shadow: var(--road-elevation-hight);
}

@media (min-width: 768px) {

  .modal-content {
    height: auto;
    border-radius: 0.25rem;
  }
}

/* HEADER
 -------------------- */

.modal-header {
  display: flex;
  align-items: center;
  justify-content: flex-end;
  color: var(--road-on-header-surface);
  background: var(--road-header-surface);
}

.modal-header road-icon {
  color: var(--road-header-icon);
}

@media (min-width: 768px) {

  .modal-header {
    border-radius: 0.25rem 0.25rem 0 0;
  }
}

/**
 * Modal header inverse colors
 */

.modal-header-inverse {
  color: var(--road-on-surface);
  background: none;
}

.modal-header-inverse road-icon {
  color: var(--road-icon);
}

/* ACTIONS
 -------------------- */

.modal-action,
.modal-close {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 3.5rem;
  height: 3.5rem;
  padding: 0;
  font-weight: 700;
  color: inherit;
  cursor: pointer;
  background: transparent;
  border: 0;
  appearance: none;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

.modal-action ~ .modal-title,
.modal-close ~ .modal-title {
  padding-left: 0;
}

.modal-action-left,
.modal-close-left {
  margin-right: auto;
}

/* TITLE
 -------------------- */

.modal-title {
  display: flex;
  flex-grow: 1;
  align-items: center;
  justify-content: center;
  height: 3.5rem;
  padding-left: 3.5rem;
  margin: 0;
  font-size: var(--road-body-medium);
  font-weight: 400;
}

/* BODY
 -------------------- */

.modal-body {
  padding: 2.5rem 0.5rem;
  overflow-y: auto;
}

.modal-header-inverse + .modal-body {
  padding-top: 0;
}

@media (min-width: 768px) {

  .modal-body {
    max-height: 86vh;
    padding-right: var(--road-spacing-06);
    padding-bottom: var(--road-spacing-06);
    padding-left: var(--road-spacing-06);
  }
}
